
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <sys/time.h>
#include <string.h>

#include "command.h"
#include "comport.h"


#define LAST_CMD_BYTE          '!'
#if 1
#define FIRST_INFO_BYTE        '4'
#define SECOND_INFO_BYTE       '4'
#else
#define FIRST_INFO_BYTE        0xC4
#define SECOND_INFO_BYTE       0xC4
#endif

int SendCommand(char* command) {

    unsigned char write_data[3];
    
    write_data[2] = LAST_CMD_BYTE;
    if (!strcmp(command, DISCOVERY_CMD)) {
        write_data[0] = FIRST_INFO_BYTE;
        write_data[1] = SECOND_INFO_BYTE;
    } else {
        return 0;
    }
    return WriteCommandToPort(write_data);

}

char DataInComBuffer(void) {

    int comPort = GetSerialPort();
    char buff[2] = "\0";  
    int foundAt = 0;
    int foundQuestionMark = 0;
    char ret = 'X';
    int i = 0;
    int readByte;
#ifdef DEBUG    
    printf("DataInComBuffer Enter\n");
#endif
    int pcr = 0;
    do {  
        i++;
        pcr = PortComIsReady(1,0); 
        if (pcr == 0) { 
#ifdef DEBUG                
            printf("PortComIsReady() returns %d \n", pcr);
#endif            
            continue;
        }  
        readByte = read(comPort, buff, 1);

        if (buff[0] == '@') {
            foundAt = 1;
            buff[0] = '\0';
#ifdef DEBUG          
            printf(">>>>>>>>>>>>>>>> FOUND @ <<<<<<<<<<<<<<<<<");
#endif            
            break;
        } else if (buff[0] == '?') {
            foundQuestionMark = 1;
        }       
        buff[0] = '\0'; 
     } while (readByte != 0 && pcr > 0);

 
    if (foundAt == 1) {        
        ret = '@';
#ifdef DEBUG        
        printf("DataInComBuffer Exit, i = [%d], ret = %c\n", i, ret);
#endif        
        return ret; 
    } else if (foundQuestionMark == 1) {
        ret = '?';
#ifdef DEBUG        
        printf("DataInComBuffer Exit, i = [%d], ret = %c\n", i, ret);
#endif        
        return ret; 
    } else {
        ret = 'X';
    }
#ifdef DEBUG    
    printf("DataInComBuffer Exit, i = [%d], ret = %c\n", i, ret);
#endif    
    return ret; 
}


int WriteCommandToPort(unsigned char write_data[]) {

    int openedComPort = GetSerialPort();
    char bufFlag = 'x';

    if (GetComPortStatus() == -10) { 
        PortComIsReady(1,0);
    } 

    tcflush(openedComPort, TCIOFLUSH);
    write_to_serial(openedComPort, write_data, 0);
    usleep(10000);
    bufFlag = DataInComBuffer();
    if (bufFlag == '?') {
        write_to_serial(openedComPort, write_data, -1);
        usleep(10000);
        bufFlag = DataInComBuffer();
        if (bufFlag == '@') {
            return 0;
        } 
#ifdef DEBUG        
        else {
            printf("Received [%c]\n", bufFlag);
        }
#endif
    } else {
        write_to_serial(openedComPort, write_data, 1);
        usleep(10000);
            bufFlag = DataInComBuffer();
            if (bufFlag == '?') {
                write_to_serial(openedComPort, write_data, -1);
                usleep(10000);
                bufFlag = DataInComBuffer();
                if (bufFlag == '@') {
                    return 0;
                } 
#ifdef DEBUG                
                else {
                    printf("Received [%c]\n", bufFlag);
                }
#endif
            } else {
            write_to_serial(openedComPort, write_data, 2);
            usleep(10000);
            bufFlag = DataInComBuffer();
            if (bufFlag == '@') {
                return 0; 
            } else {
#ifdef DEBUG                
                printf("Received [%c], port is dead\n", bufFlag);
#endif                
                return 5;
            } 
        }
    }
    return -1; 
}
