/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Logger Software Package

# AMFELTEC System Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "comport.h"
#include "command.h"


int main(int argc, char *argv[]) {

    if (!strcmp(argv[1], DISCOVERY_CMD)) {
        if (argc != 3) {
            printf("Wrong command format\n");
            return EXIT_FAILURE;
        }
        if (open_serial_port(argv[2]) == 0) {
            if (0 == SendCommand(DISCOVERY_CMD)) {     
                // means we got '@' - NEVER(!!!) comment out the following printf()
                // it seves as output for usb_port.sh script
                read_info_from_port(GetSerialPort());
                printf("Got @ acknowledge\n");
                return EXIT_SUCCESS;
            } else {
                return EXIT_FAILURE;
            }
        } else {
            return EXIT_FAILURE;
        }
    }
    return EXIT_SUCCESS;
}