#!/bin/bash

MICROCHIP_ID="XR17V35X"

SERIALS=$(sudo dmesg | grep "$MICROCHIP_ID")

SERIAL_LIST=($(echo "$SERIALS" | awk '{print $4}'))

for ((i = 0; i < ${#SERIAL_LIST[@]}; i++)); do
    sudo chmod +x discovery
    sudo chmod 666 /dev/${SERIAL_LIST[$i]}
    echo ${SERIAL_LIST[$i]}
    output=$(./discovery port /dev/${SERIAL_LIST[$i]})
    if [[ $output == *'@'* ]]; then
        if [[ $output == *"WD"* ]]; then 
            ttyWDCOM_variable="WD_COM_PORT"
            ttyWDCOM_value="/dev/${SERIAL_LIST[$i]}"
            declare "$ttyWDCOM_variable=$ttyWDCOM_value"

            export "$ttyWDCOM_variable"
            echo "export ttywdCOM_value=\"$ttyWDCOM_value\"" >> ~/.bashrc
            echo "Exported $ttyWDCOM_variable with value $ttyWDCOM_value"


        else
            ttyLOGCOM_variable="LOG_COM_PORT"
            ttyLOGCOM_value="/dev/${SERIAL_LIST[$i]}"
            declare "$ttyLOGCOM_variable=$ttyLOGCOM_value"
            
            export "$ttyLOGCOM_variable"
            echo "export ttyLOGCOM_value=\"$ttyLOGCOM_value\"" >> ~/.bashrc
            echo "Exported $ttyLOGCOM_variable with value $ttyLOGCOM_value"

        fi
 
    else
        sudo chmod 555 /dev/${SERIAL_LIST[$i]}
        sudo chmod -x /dev/${SERIAL_LIST[$i]}
    fi

done