/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Logger Software Package

# AMFELTEC System Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "configfile.h"

KeyValue Pairs[MAX_SETTINGS_NUMBER];

KeyValue* GetSettingsFromFile(void){

    char line[80];
    int count = 0;

    unsigned char key, value;
    
    FILE *file = fopen(CONFIG_FILE, "r");
    if (file == NULL) 
    {
        perror("Error opening config file");
        return NULL;
    }
    for (int i = 0; i < MAX_SETTINGS_NUMBER; i++) {
        Pairs[i].Key = -1;
        Pairs[i].Value = -1;
    }
    while (fgets(line, sizeof(line), file)) {

        if (line[0] == '#') {
            continue;
        } 

        if (sscanf(line, "%hhu:%hhu", &key, &value) == 2) {
            Pairs[count].Key = key;
            Pairs[count].Value = value;
            count++;
        }
    }
    fclose(file);
#ifdef DEBUG 
    printf("Key:Value pairs:\n");
    for (int i = 0; i < count; i++){
        printf("Pair %d: Key = %d, Value = %hhu\n", i+1, Pairs[i].Key, Pairs[i].Value);
    }
#endif    
    if (count == 0) 
        return NULL;
    return Pairs;
}
