/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Logger Software Package

# AMFELTEC System Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "dataconv.h"

long int getPressure(long int msb, long int mid) {
    return (((msb << 8) + mid) >> 5) & 0x7ff;
}

long int getHumidity(long int msb, long int lsb){
    char ret = 0;
    
    ret = ((((msb << 8) + lsb) * 125) >> 16) - 6; 
    if (ret < 0)
        ret = 0;
    else if (ret > 100)
        ret = 100;
    return ret;        
}

long int getBmTemperature(long int msb, long int lsb){
    double retVal;

    retVal = ((msb << 8) + lsb) / 32;
    return retVal;
}


