/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of USB Logger Software Package

# USB Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# USB Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/
#ifndef _OUTPUT_UTILS_H_
#define _OUTPUT_UTILS_H_

#include <stdlib.h>

#ifndef FINAL_DUMP_FILE
#define FINAL_DUMP_FILE     "data/finarray_int.txt"
#endif
#ifndef FINAL_LOG
#define FINAL_LOG           "data/finarray.txt"
#endif
#ifndef STATUS_FILE
#define STATUS_FILE         "data/status.txt"
#endif
#ifndef ACEL_FILE
#define ACEL_FILE           "data/acel.txt"
#endif
#ifndef TEMP_DUMP_FILE
#define TEMP_DUMP_FILE      "data/dump.txt"
#endif
#ifndef DATA_SUBDIRECTORY
#define DATA_SUBDIRECTORY   "data" 
#endif




void zero_out_file_streams(void);
int write_status_header(void);
int write_accel_header(void);
int add_line_to_status_file(char* line);
int add_line_to_acel_file(char* line);
int add_line_to_dump_file(char* line);
int write_to_dump_file(char *array);

int open_files(void);
void close_files(void);

#endif