/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Logger Software Package

# AMFELTEC System Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/

#ifndef _PARSER_H_
#define _PARSER_H_
#include "configfile.h"

// allowed commands
#define INFO_CMD     "info"
#define DUMP_CMD     "dump"
#define SET_CMD      "set"
#define PROD_TEST    "ptest"
#define WARM_RESTART "wrestart"
#define FIRST_START  "fstart"
#define PORT_NAME    "port"


void read_dump_from_port(void);
void read_info_from_port(int serialPort);
void read_test_data_from_port(int serialPort);

void process_data(char * commonArray);

int SendBatchCommand(KeyValue* batch);
int SendCommand(char * command);
int WriteCommandToPort(unsigned char write_data[]);



#endif // _PARSER_H_