/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Logger Software Package

# AMFELTEC System Logger Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Logger Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/

#ifndef _PARSUTILS_H_
#define _PARSUTILS_H

#define STATUS_START_FLAG_1  "0x13"
#define STATUS_START_FLAG_2  "0x16"
#define STATUS_END_FLAG_1    "0x12"
#define STATUS_END_FLAG_2    "0x15"
#define STATUS_DATA_SIZE     6

#define ACEL_START_FLAG_1  "0x14"
#define ACEL_START_FLAG_2  "0x17"
#define ACEL_END_FLAG      "0x18"
#define ACEL_DATA_SIZE     3


// returns idx of first entry of start flags pair, otherwise -1
int status_block_start(char* array[], int idx, int maxIdx);

// returns idx of first entry of end flags pair, otherwise -1
int status_block_end(char* array[], int idx, int maxIdx);

// returns idx of first entry of start flags pair, otherwise -1
int acel_block_start(char* array[], int idx, int maxIdx);

// returns idx of end flag, otherwise -1
int acel_block_end(char* array[], int idx, int maxIdx);

// extracts status block
// returns block size
int status_block(char* array[], int idx, int maxIdx);

// extracts accelleration block
// returns block size
int acel_block(char* array[], int idx, int maxIdx);

int containsOnlyPrintableAscii(const char *str);

int post_process_finarray(void);


#endif