/*****************************************************************************
* Copyright:    (c) 2024 AMFELTEC Corp.
* ----------------------------------------------------------------------------
This file is part of AMFELTEC System Watchdog Software Package

# AMFELTEC System Watchdog Software Package 
# is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# AMFELTEC System Watchdog Software Package
# is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License.
# If not, see <https://www.gnu.org/licenses/>

*****************************************************************************/
#ifndef _COMMAND_H_
#define _COMMAND_H_

//allowed commands
#define START_WD_CMD   "start"   //3 optional parameters 
#define STOP_WD_CMD    "stop"
#define REFRESH_WD_CMD "refresh" //1 optional parameter
#define INFO_WD_CMD    "info"
#define SET_WD_CMD     "timer"   //5 optional parameters 

#define DEF_Wdog_INT            10  // in 1 sec steps   - T1
#define DEF_RESET_INT           10  // in 10 msec steps - T2
#define DEF_PWR_OFF_INT         5   // in 1 sec steps   - T3 
#define DEF_PWR_WAIT_INT        5   // in 1 sec steps   - T4
#define DEF_PWR_ON_INT          10  // in 10 msec steps - T5  

#define NUMBER_OF_TIMERS        5

int SendCommand(char * command);
int SendTimerCommand(char timers[]);
int SendControlCommand(char r, char p, char u);
void SendRefresh(int param);
//int WriteCommandToPort(unsigned char write_data[]);


#endif  // _COMMAND_H_